#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <stdbool.h>

void usage(void)
{
	fprintf(stderr, "usage:\n");
	fprintf(stderr, "\toptions -i network-device -s aa:bb:cc:dd:ee:ff:gg (send to mac-addr) \n"
	                "\t-r hh:ii:jj:kk:ll:mm  (reveive: my own mac-addr) -v\n");
	fprintf(stderr, "\t-d debuglevel (BITMASK)  -t testmode (bitmask)\n");
	fprintf(stderr, "\t        \n");

	fprintf(stderr, "\t      debug  (bitmask)\n");
	fprintf(stderr, "\t           1  -> fixme,    2  -> fixme,    4  -> fixme\n");
	fprintf(stderr, "\t        %4d -> in packets, %4d -> machting header, %4d -> listening\n",deb_recpkt,deb_match,deb_listen);
	fprintf(stderr, "\t        %4d -> print send packets, 256-> fixme\n",deb_send);
	fprintf(stderr, "\t        %4d -> print set port commands\n",deb_port);
	fprintf(stderr, "\t        \n");



	fprintf(stderr, "\t     testmode (bitmask)\n");
	fprintf(stderr, "\t	   1 -> do not send\n");
	fprintf(stderr, "\t	   2 -> do not receive\n");
	fprintf(stderr, "\t	   4 -> endless send-receive-loopback\n");
	fprintf(stderr, "\t	%4d -> endless flood sending\n",testmode_sflood);
	fprintf(stderr, "\t        \n");

	fprintf(stderr, "\nDescription:\n");
	fprintf(stderr, "\tThis utility is part of the linuxcnc-rasPI project\n"
			"\thttp://erste.de/rasPiCat.html\n\n"
			"give MAC (r) address and name of local (-d) and MAC of corresponding device (-s)."
			"\n");

	exit(EXIT_FAILURE);
}

unsigned char smac[ETH_ALEN];   //send to MAC
unsigned char rmac[ETH_ALEN];   //receive for MAC

int getCLopt(int argc, char **args)
{
	int sock, err = 0, opt;
	bool has_mac = false, has_dev = false, verbose = false,num=10;
	bool has_dmac=false,has_rmac=false;

	while ((opt = getopt(argc, args, "r:s:i:v:d:t:")) != -EXIT_FAILURE) {
		switch (opt) {
		case 'i':
			has_dev = true;
			strncpy(dev_name, optarg, IFNAMSIZ);
	        fprintf(stdout, "Opening interface [%s].\n", dev_name);
			break;

		case 'r':
			has_rmac = true;
			err = sscanf(optarg, MAC_STR, MAC_ARG(rmac)) != 6;
         		fprintf(stdout, "recieve for Mac-address ["MAC_STR"].\n", MAC_ARG2(rmac));

			break;

		case 's':
			has_dmac = true;
			err = sscanf(optarg, MAC_STR, MAC_ARG(smac)) != 6;
         		fprintf(stdout, "send to  Mac-address ["MAC_STR"].\n", MAC_ARG2(smac));
			break;
		case 'v':
			verbose = true;
			break;

		case 'd':
			debug = atoi( optarg );
			printf("running debung level:%4d\n",debug);
			printBits(2,(void const * )&debug);
			break;

		case 't':
			testmode = atoi( optarg );
			printf("running in testmode:%4d\n",testmode);
			printBits(2,&testmode);
			break;




		default:
			err = -EINVAL;
			break;
		}

		if (err)
			break;
	}

	if (!has_dmac || !has_rmac || !has_dev || err)
		usage();



	if (err < 0)
		return EXIT_FAILURE;
	return 0;
}

