/******************************************************************************
 *
 * Copyright (c) 2019 by Ralf Burger (ralf@Burger-AG.de)
 *
 * Raw-Ethernet component driver-tester (raspberry and  arduino)
 *
 *       LinuxCNC - Arduino-/Raspberry- IO
 *       pcIOethRaw.c  - (c) by Ralf Burger 2019 -
 *       V.: 0.6 Last change:  23.02.2019
 *
 * Description:
 * A direct ethernet-connection to the correspondig linuxCNC-eth-device
 * is nessesarry.
 * This programm sends raw-eth-packets to a connected arduino or raspberry
 *
 * Author: Ralf Burger
 * License: GPL Version 2
 *
 * Copyright (c) 2019 All rights reserved.
 *
 *
 ******************************************************************************
 *
 * keys 1-8 = toggles bit 0-7 of output-byte
 * "+" shifts betweeen output-byte [0-3]
 * "x" = exit
 *
 ******************************************************************************
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *
 * THE AUTHORS OF THIS PROGRAM ACCEPT ABSOLUTELY NO LIABILITY FOR
 * ANY HARM OR LOSS RESULTING FROM ITS USE.  IT IS _EXTREMELY_ UNWISE
 * TO RELY ON SOFTWARE ALONE FOR SAFETY.  Any machinery capable of
 * harming persons must have provisions for completely removing power
 * from all motors, etc, before persons enter any danger area.  All
 * machinery must be designed to comply with local and national safety
 * codes, and the authors of this software can not, and do not, take
 * any responsibility for such compliance.
 *
 * This code was written as part of the LinuxCNC project.  For more
 * information, go to www.linuxcnc.org.
 *
 ******************************************************************************/





#include <time.h>
#include <termios.h>
#include <assert.h>
#include <pthread.h>
#include <sys/mman.h>
#include <limits.h>

#include <arpa/inet.h>
#include <linux/if_packet.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
//#include <sched.h>

#include <fcntl.h>
#include <sys/io.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include <stdio.h>
#include <string.h>


#include <sys/ioctl.h>
#include <sys/socket.h>
#include <netinet/ether.h>
#include <sys/ioctl.h>
#include <linux/if.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>
#include <arpa/inet.h>
#include <linux/udp.h>
#include <linux/ip.h>



#include "defs.h"
#include "commandline.c"
#include "func.c"
//#include "rtapi.h"              /* user-level API to RT Linux */
//#include "hal.h"
//#include "common.h"

/////////////////
static int module;
//static int key = SHMEM_KEY;
//static SHMEM_STRUCT *shmem_struct;

int send_data(){
// this part is sending.
        int do_send=false;
	if (lastout[0]!=port_data_array->outval[0])do_send=true;
	if (lastout[1]!=port_data_array->outval[1])do_send=true;
	if (lastout[2]!=port_data_array->outval[2])do_send=true;
	if (lastout[3]!=port_data_array->outval[3])do_send=true;
	if (lastout[4]!=port_data_array->outval[4])do_send=true;

        if  ((testmode & testmode_sflood)>0) do_send=true;

//	printf("do_send: %2d, lastout[0]: %2x  outval[0]: %2x    ",do_send,lastout[0],port_data_array->outval[0]);
//	printf("do_send: %2d, lastout[1]: %2x  outval[1]: %2x\n",do_send,lastout[1],port_data_array->outval[1]);
	if (do_send) {
		if ((debug & deb_send)>0){
			printf("port_data_array->outval[0] %2x last:%2x\n",port_data_array->outval[0],lastout[0]);
			printBits(1,&port_data_array->outval[0]);	
		}
		sndbuf[12]=0x08;
		sndbuf[13]=0x08;  //set type
		sndbuf[14]=0x08;  // type
		sndbuf[15]='I';   // 0x049  key  
		sndbuf[16]=0;     // second byte
		sndbuf[17]=port_data_array->outval[0];
		sndbuf[18]=port_data_array->outval[1];
		sndbuf[19]=port_data_array->outval[2];
		sndbuf[20]=port_data_array->outval[3];
		sndbuf[21]=port_data_array->outval[4];
		sndbuf[22]=0;     // second byt
		sndbuf[23]=sndcount;
		sndbuf[24]=sndcount;
		/* Index of the network device */
		socket_address.sll_ifindex = if_idx.ifr_ifindex;
		/* Address length*/
		socket_address.sll_halen = ETH_ALEN;
		/* Destination MAC */
		socket_address.sll_addr[0] = smac[0];
		socket_address.sll_addr[1] = smac[1];
		socket_address.sll_addr[2] = smac[2];
		socket_address.sll_addr[3] = smac[3];
		socket_address.sll_addr[4] = smac[4];
		socket_address.sll_addr[5] = smac[5];
                sndbuf[0] = smac[0];
                sndbuf[1] = smac[1];
                sndbuf[2] = smac[2];
                sndbuf[3] = smac[3];
                sndbuf[4] = smac[4];
                sndbuf[5] = smac[5];

                sndbuf[6] = rmac[0];
                sndbuf[7] = rmac[1];
                sndbuf[8] = rmac[2];
                sndbuf[9] = rmac[3];
                sndbuf[10] = rmac[4];
                sndbuf[11] = rmac[5];

	
		//sleep (1);
		/* Send packet */
		if (debug & deb_send){

			print_buf(sndbuf);
		}

//		if (sendto(s_sockfd, sndbuf, tx_len, 0, (struct sockaddr*)&socket_address, sizeof(struct sockaddr_ll)) < 0) 
		int sent=write(s_sockfd, sndbuf, 30); /*tx_len*/
		if (sent<0) {

			perror("SENDTO");
			printf("Send failed\n");
			return -1;
			}
		if (debug & deb_send) printf("sent: %d\n",sent);
		lastout[0]=port_data_array->outval[0];
		lastout[1]=port_data_array->outval[1];
		lastout[2]=port_data_array->outval[2];
		lastout[3]=port_data_array->outval[3];
		lastout[4]=port_data_array->outval[4];
		sndcount=sndcount+1;
		}

// end of sending part
}
static unsigned char lastEthInNr=0, pktInNr=0;
static bool firstEthIn=false;




int rec_data(){
// receiving part

	bool doit=false;

        int count=0;
	bool isForMe=false;  // is it a packet for me?

        if ((DEBUG & DEB_LISTLOOP)>0) printf("listener: Waiting to recvfrom...\n");
      numbytes = recvfrom(r_sockfd, recbuf, BUF_SIZ, 0, NULL, NULL);
        if (numbytes==-1) {return 0;}
	if (DEBUG == DEB_ALL) print_header();
        if (debug & deb_recpkt) printf("listener: got packet %lu bytes\n", numbytes);

        /* Check the packet is for me */
        if (            rec_header->h_dest[0] == rmac[0]   &&
                        rec_header->h_dest[1] == rmac[1]   &&
                        rec_header->h_dest[2] == rmac[2]   &&
                        rec_header->h_dest[3] == rmac[3]   &&
                        rec_header->h_dest[4] == rmac[4]   &&
                        rec_header->h_dest[5] == rmac[5]  ) {
                if (DEBUG & DEB_CORRECT_MAC)printf("Correct destination MAC address  %x:%x:%x:%x:%x:%x\n",
                                                rec_header->h_dest[0],
                                                rec_header->h_dest[1],
                                                rec_header->h_dest[2],
                                                rec_header->h_dest[3],
                                                rec_header->h_dest[4],
                                                rec_header->h_dest[5]);
						isForMe=true;		
					if (DEBUG && DEB_PACKET) print_header();


        } else {
                if (DEBUG & DEB_WRONG_MAC) printf("Wrong destination MAC: %x:%x:%x:%x:%x:%x\n",
                                                rec_header->h_dest[0],
                                                rec_header->h_dest[1],
                                                rec_header->h_dest[2],
                                                rec_header->h_dest[3],
                                                rec_header->h_dest[4],
                                                rec_header->h_dest[5]);
		isForMe=false;
        }


	if (DEBUG & DEB_WRONG_MAC) 
 printf("packet is from MAC: %x:%x:%x:%x:%x:%x\n",rec_header->h_source[0],
                                                rec_header->h_source[1],
                                                rec_header->h_source[2],
                                                rec_header->h_source[3],
                                                rec_header->h_source[4],
                                                rec_header->h_source[5]);
	


	 if (DEBUG & DEB_WRONG_MAC) if            (rec_header->h_source[0] != smac[0] &&
                        rec_header->h_source[1] != smac[1]   &&
                        rec_header->h_source[2] != smac[2]   &&
                        rec_header->h_source[3] != smac[3]   &&
                        rec_header->h_source[4] != smac[4]   &&
                        rec_header->h_source[5] != smac[5]  ) {printf("wrong sender - ignored...\n");isForMe=false;}


	if (isForMe) {
if (debug & deb_match)	print_header();

        /* Print packet */
        if (DEBUG & DEB_PACKET){
			 printf("\tData:");
        		for (i=0;  i<6; i++) printf("%2x:", (unsigned int) (recbuf[i]&0xff));
			printf (" - ");
        		for (i=6;  i<12; i++) printf("%2x:", (unsigned int) (recbuf[i]&0xff));
			printf (" - ");
        		for (i=13; i<15; i++) printf("%2x:", (unsigned int) (recbuf[i]&0xff));
        		printf("\n");
	}
        if (DEBUG & DEB_PAYLOAD){
                printf("a:%02x:", recbuf[14]);
                printf("b:%02x:", recbuf[15]);
                printf("\n");
        }
	if (debug>0)   print_buf(recbuf);
	doit=lastin[0]!=(unsigned char)recbuf[17];
	if (lastin[1]!=(unsigned char)recbuf[18]) doit=true;
	if (lastin[2]!=(unsigned char)recbuf[19]) doit=true;
	if (lastin[3]!=(unsigned char)recbuf[20]) doit=true;
	if (lastin[4]!=(unsigned char)recbuf[21]) doit=true;
        if (doit){
        if (DEBUG & DEB_MOTOR)printf("B14: %02x ", recbuf[14]);
        lastin[0]=recbuf[17];
        lastin[1]=recbuf[18];
        lastin[2]=recbuf[19];
        lastin[3]=recbuf[20];
        lastin[4]=recbuf[21];
        pktInNr=recbuf[24];
        if (firstEthIn) {firstEthIn=false;lastEthInNr=pktInNr-1;}
        if (debug&2048)
		 printf("lastEthInNr:%4x pktInNr:%4x pktInNr-1:%4x-1\n",lastEthInNr,pktInNr,((pktInNr-1)&255));


        if (lastEthInNr!=((pktInNr-1)&255)){printf("PACKET LOST!!!lastEthInNr:%4x pktInNr:%4x\n",lastEthInNr,pktInNr);}
        lastEthInNr=pktInNr;

        port_data_array->inval[0]=lastin[0];            
        port_data_array->inval[1]=lastin[1];             
        port_data_array->inval[2]=lastin[2];             
        port_data_array->inval[3]=lastin[3];             
        port_data_array->inval[4]=lastin[4];            
        if (DEBUG & DEB_OUTBITS) printBits(1,&port_data_array->inval[0]);
        if (debug>0) printf("recbuf[17]:%d\n",port_data_array->inval[0]);
//      port_data_array->inval[0]=fx;  //debugging-fun
//      fx++;
        }
        count++;
        if (count>100000){
        print_stamp();


                printf(" 100k packtes received.\n");
                count=0;
                }
	}  // isForMe   
//        print_stamp();
	// end of receiving part
}


















void  *thread_func(void *data){
//////////////////////////////////////////////////////////////
	int lcount=0;
while (1==1) {
	lcount++;
//	usleep (250);
	if ((testmode & 1)==0)	send_data();
	if ((testmode & 2)==0)  rec_data();
	if (testmode & 4){
	        port_data_array->inval[0]= port_data_array->inval[0]= ~port_data_array->inval[0]; // ^= 2;
	        port_data_array->outval[0]= port_data_array->outval[0]= ~port_data_array->outval[0]; // ^= 2;
	//	 printf("->%2x\n",port_data_array->inval[0]); 
//		usleep(1);
		if (lcount>100000){lcount=0;print_stamp();printf(" 100k packets sent\n"); }	
	}
//	usleep(10);
//	sched_yield();
	}

//////////////////////////////////////////////////////////////////////////////////

}



int main(int argc, char *argv[])
{
printf("test-tool - running on pc-linuxcnc-side\n");
printf("23.2.2019 RB\n");

printf("compile with \n");
printf("gcc  pcIOethRaw.c -o pcIOethRaw -pthread\n");

printf("\n");

	getCLopt(argc, argv);
printf("destination MAC: %02x:%02x:%02x:%02x:%02x:%02x\n",
        smac[0],
        smac[1],
        smac[2],
        smac[3],
        smac[4],
        smac[5]);

        s_dstMac[0] =smac[0];
        s_dstMac[1] =smac[1];
        s_dstMac[2] =smac[2];
        s_dstMac[3] =smac[3];
        s_dstMac[4] =smac[4];
        s_dstMac[5] =smac[5];

printf("rec. for MAC: %02x:%02x:%02x:%02x:%02x:%02x\n",
        rmac[0],
        rmac[1],
        rmac[2],
        rmac[3],
        rmac[4],
        rmac[5]);

        r_srcMac[0] =rmac[0];
        r_srcMac[1] =rmac[1];
        r_srcMac[2] =rmac[2];
        r_srcMac[3] =rmac[3];
        r_srcMac[4] =rmac[4];
        r_srcMac[5] =rmac[5];



/*
	if (get_shmem()<0) {
	perror("get_shmem");
	}
*/
	/* Open RAW socket to send on */
	if ((s_sockfd = socket(AF_PACKET, SOCK_RAW, IPPROTO_RAW)) == -1) {
	    perror("socket");
	}

	/* Get the index of the interface to send on */
	memset(&if_idx, 0, sizeof(struct ifreq));
	strncpy(if_idx.ifr_name, dev_name, IFNAMSIZ-1);
	printf("interface:%s\n",dev_name);
memset(sndbuf, 0, BUF_SIZ);

snd_header->h_source[0] = ((uint8_t *)&if_mac.ifr_hwaddr.sa_data)[0];
snd_header->h_source[1] = ((uint8_t *)&if_mac.ifr_hwaddr.sa_data)[1];
snd_header->h_source[2] = ((uint8_t *)&if_mac.ifr_hwaddr.sa_data)[2];
snd_header->h_source[3] = ((uint8_t *)&if_mac.ifr_hwaddr.sa_data)[3];
snd_header->h_source[4] = ((uint8_t *)&if_mac.ifr_hwaddr.sa_data)[4];
snd_header->h_source[5] = ((uint8_t *)&if_mac.ifr_hwaddr.sa_data)[5];
snd_header->h_dest[0] = smac[0];
snd_header->h_dest[1] = smac[1];
snd_header->h_dest[2] = smac[2];
snd_header->h_dest[3] = smac[3];
snd_header->h_dest[4] = smac[4];
snd_header->h_dest[5] = smac[5];
snd_header->h_proto =  htons(ETH_P_IP);
tx_len += sizeof(struct ether_header)+2;

init_rec_socket();
init_snd_socket();

// -------

init_thread();
char c='y';int mode=0;int byte=0;int f=0;
port_data_array->inval[0]=0;
while (c!='x'){
	c = getch();
        if (c == 'i') mode=0;
        if (c == 'o') mode=1;
        if (c == '+') {byte++; if (byte==4) byte=0; printf("IO-byte:%01d\n",byte);}



        for (f=1; f<=8; f++){
           if(c == 48+f){
                printf("(1<<f):=%2d\n",(1<<f-1));
                if (mode==0){
                        printf(" toggle IN bit %01d of byte[%01d]\n",f,byte);
                        printf("%2x:",port_data_array->inval[byte]);
                        port_data_array->inval[byte] ^= (1<<(f-1));
                        printf("->%2x\n",port_data_array->inval[byte]);
                        }
                if (mode==1){
                        printf(" toggle OUT bit %01d of byte[%01d]\n",f,byte);
                        printf("%2x:",port_data_array->outval[byte]);
                        port_data_array->outval[byte] ^= (1<<(f-1));
                        printf("->%2x\n",port_data_array->outval[byte]);
                        }
                }
             }
/*
  	 port_data_array->outval[0] ^= (1<<(3));
	 usleep(10);
	 port_data_array->outval[0] ^= (1<<(3));
	 usleep(10);
*/	 
}


	return 0;
}





